"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var fse = require("fs-extra");
var getCompileDeps_1 = require("./getCompileDeps");
var getCacheContent_1 = require("./getCacheContent");
var preBuild_1 = require("./preBuild");
var configApp_1 = require("./configApp");
var remoteRuntime = function (api, options) { return __awaiter(void 0, void 0, void 0, function () {
    var context, pkg, command, rootDir, userConfig, _a, _b, activeInBuild, _c, bootstrap, rest, activeRemoteRuntime, cacheDir, cacheFile, runtimeDir, remoteName, remoteEntry, packageKeys, compilePackages, lastCache, cacheContent, needPreBuild;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                context = api.context;
                pkg = context.pkg, command = context.command, rootDir = context.rootDir, userConfig = context.userConfig;
                _a = typeof options === 'boolean' ? {} : options, _b = _a.activeInBuild, activeInBuild = _b === void 0 ? false : _b, _c = _a.bootstrap, bootstrap = _c === void 0 ? '' : _c, rest = __rest(_a, ["activeInBuild", "bootstrap"]);
                activeRemoteRuntime = activeInBuild || command === 'start';
                if (!activeRemoteRuntime) {
                    return [2 /*return*/];
                }
                cacheDir = path.join(rootDir, 'node_modules', '.cache', 'runtime');
                cacheFile = path.join(cacheDir, 'cache.json');
                runtimeDir = path.join(cacheDir, 'remoteRuntime');
                remoteName = 'remote_runtime';
                remoteEntry = 'remoteEntry.js';
                packageKeys = Object.keys(pkg.dependencies || {});
                return [4 /*yield*/, getCompileDeps_1.default(packageKeys, rootDir, rest)];
            case 1:
                compilePackages = _d.sent();
                // ensure cache dir
                fse.ensureDirSync(cacheDir);
                lastCache = '';
                try {
                    lastCache = fse.readFileSync(cacheFile, 'utf-8');
                }
                catch (err) {
                    // ignore err when read file
                }
                cacheContent = getCacheContent_1.default({ compilePackages: compilePackages, rootDir: rootDir, userConfig: userConfig });
                needPreBuild = lastCache !== cacheContent;
                if (needPreBuild) {
                    preBuild_1.default(api, { remoteName: remoteName, remoteEntry: remoteEntry, runtimeDir: runtimeDir, cacheFile: cacheFile, cacheDir: cacheDir, cacheContent: cacheContent, compilePackages: compilePackages });
                }
                // modify webpack config for main app
                configApp_1.default(api, { remoteName: remoteName, bootstrap: bootstrap, compilePackages: compilePackages, remoteEntry: remoteEntry, runtimeDir: runtimeDir });
                return [2 /*return*/];
        }
    });
}); };
exports.default = remoteRuntime;
//# sourceMappingURL=index.js.map