"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var glob = require("fast-glob");
var es_module_lexer_1 = require("es-module-lexer");
var esbuild_1 = require("esbuild");
function globFiles(pattern, rootDir) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, glob(pattern, {
                        cwd: rootDir,
                        ignore: [
                            '**/node_modules/**',
                            // ignore apis folder for default
                            'src/apis/**',
                            '**/__tests__/**',
                        ],
                        absolute: true,
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function scanImports(globPatterns, rootDir) {
    return __awaiter(this, void 0, void 0, function () {
        var importSet, files;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    importSet = new Set();
                    return [4 /*yield*/, globFiles(globPatterns, rootDir)];
                case 1:
                    files = _a.sent();
                    return [4 /*yield*/, Promise.all(files.map(function (filePath) {
                            return (function () { return __awaiter(_this, void 0, void 0, function () {
                                var source, lang, loader, imports, err_1;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            source = fs.readFileSync(filePath, 'utf-8');
                                            lang = path.extname(filePath).slice(1);
                                            loader = 'jsx';
                                            if (lang === 'ts' || lang === 'tsx') {
                                                loader = lang;
                                            }
                                            _a.label = 1;
                                        case 1:
                                            _a.trys.push([1, 4, , 5]);
                                            return [4 /*yield*/, esbuild_1.transform(source, { loader: loader })];
                                        case 2:
                                            // transform content first since es-module-lexer can't handle ts file
                                            source = (_a.sent()).code;
                                            return [4 /*yield*/, es_module_lexer_1.init];
                                        case 3:
                                            _a.sent();
                                            imports = es_module_lexer_1.parse(source)[0];
                                            imports.forEach(function (importSpecifier) {
                                                var importName = importSpecifier.n;
                                                // filter source code
                                                if (!importName.startsWith('.') && !importName.startsWith('@/') && !importName.startsWith('ice/')) {
                                                    importSet.add(importSpecifier.n);
                                                }
                                            });
                                            return [3 /*break*/, 5];
                                        case 4:
                                            err_1 = _a.sent();
                                            console.log('transform error with:', filePath);
                                            return [3 /*break*/, 5];
                                        case 5: return [2 /*return*/];
                                    }
                                });
                            }); })();
                        }))];
                case 2:
                    _a.sent();
                    return [2 /*return*/, Array.from(importSet)];
            }
        });
    });
}
exports.default = scanImports;
//# sourceMappingURL=scanImports.js.map